//Simulation code for MoonAndEarth
//Generated by OpenModelica.

#include "modelica.h"

#include "simulation_runtime.h"

#include "MoonAndEarth_functions.cpp"

#define NHELP 0
#define NG 0
#define NX 9
#define NY 8
#define NP 2 // number of paramters
#define NO 0 // number of outputvar on topmodel
#define NI 0 // number of inputvar on topmodel
#define NR 25 // number of residuals for initialialization function
#define MAXORD 5
#define time (*t)

#if NHELP > 0 /* some c-compilers does not like a static array of |a|==0 */
double hbuf[NHELP];
double *h = &hbuf[0];
#else
double *h;
#endif
#if NX > 0
double xbuf[NX];  // STATES
double *x = &xbuf[0];
#else
double *x;
#endif
#if NX > 0
double xdbuf[NX]; // DERIVATIVES
double *xd = &xdbuf[0];
#else
double *xd;
#endif
#if NX > 0
double dummy_deltabuf[NX];
double *dummy_delta = &dummy_deltabuf[0];
#else
double *dummy_delta;
#endif
#if NY > 0
double ybuf[NY]; // ALGVARS
double *y = &ybuf[0];
#else
double *y;
#endif
#if NP > 0
double pbuf[NP];  // PARAMETERS
double *p = &pbuf[0];
#else
double *p;
#endif
#if NO > 0
double out_ybuf[NO]; // OUTPUTVARS
double *out_y = &out_ybuf[0];
#else
double *out_y;
#endif
#if NR > 0
double init_res_buf[NR];  // INIT. RESIDUALS
double *init_res = &init_res_buf[0];
#else
double *init_res;
#endif
#if NG > 0
long jrootbuf[NG];
long *jroot = &jrootbuf[0];
#else
long *jroot;
#endif
double rworkbuf[50+(MAXORD+4)*NX+NX*NX+3*NG];
double *rwork=&rworkbuf[0];
#if NI > 0
double in_ybuf[NI]; // INPUTVARS
double *in_y = &in_ybuf[0];
#else
double *in_y;
#endif
long iworkbuf[20+NX];
long *iwork=&iworkbuf[0];
long liw = 20+NX;
long lrw = 50+(MAXORD+4)*NX+NX*NX+3*NG;
long nx = NX; // STATES
long ny = NY; // ALGVARS
long np = NP; // PARAMETERS
long nr = NR; // NO. OF INIT. RESIDUALS
long ng = NG; 
long no = NO; // OUTPUTVARS
long ni = NI; // INPUTVARS 
long nhelp = NHELP;
char *model_name="MoonAndEarth";
char* state_names[9]={"moon.vy", "moon.vx", "moon.y", "moon.x", "earth.vy", "earth.vx", "earth.y", "earth.x", "$dummy"};
char* derivative_names[9]={"moon.der(vy)", "moon.der(vx)", "moon.der(y)", "moon.der(x)", "earth.der(vy)", "earth.der(vx)", "earth.der(y)", "earth.der(x)", "der($dummy)"};
char* algvars_names[8]={"alfa", "yDistance", "xDistance", "force", "moon.fy", "moon.fx", "earth.fy", "earth.fx"};
char* input_names[1] = {""};
char* output_names[1] = {""};
char* param_names[2]={"moon.mass", "earth.mass"};

char* state_comments[9]={ "velocity", "",  "coordinates", "",  "velocity", "",  "coordinates", "", ""};
char* derivative_comments[9]={ "velocity", "",  "coordinates", "",  "velocity", "",  "coordinates", "", ""};
char* algvars_comments[8]={"", "", "", "",  "force", "",  "force", ""};
char* input_comments[1] = {""};
char* output_comments[1] = {""};
char* param_comments[2]={"", ""};

char* varnamesbuf[26]={"moon.vy", "moon.vx", "moon.y", "moon.x", "earth.vy", "earth.vx", "earth.y", "earth.x", "$dummy", "moon.der(vy)", "moon.der(vx)", "moon.der(y)", "moon.der(x)", "earth.der(vy)", "earth.der(vx)", "earth.der(y)", "earth.der(x)", "der($dummy)", "alfa", "yDistance", "xDistance", "force", "moon.fy", "moon.fx", "earth.fy", "earth.fx"};

char** varnames=&varnamesbuf[0];

#define $moon$pointmass p[0]
#define $earth$pointmass p[1]
#define $alfa y[0]
#define $yDistance y[1]
#define $xDistance y[2]
#define $force y[3]
#define $moon$pointfy y[4]
#define $moon$pointfx y[5]
#define $moon$pointvy x[0]
#define $derivative$moon$pointvy xd[0]
#define $moon$pointvx x[1]
#define $derivative$moon$pointvx xd[1]
#define $moon$pointy x[2]
#define $derivative$moon$pointy xd[2]
#define $moon$pointx x[3]
#define $derivative$moon$pointx xd[3]
#define $earth$pointfy y[6]
#define $earth$pointfx y[7]
#define $earth$pointvy x[4]
#define $derivative$earth$pointvy xd[4]
#define $earth$pointvx x[5]
#define $derivative$earth$pointvx xd[5]
#define $earth$pointy x[6]
#define $derivative$earth$pointy xd[6]
#define $earth$pointx x[7]
#define $derivative$earth$pointx xd[7]
#define $$dummy x[8]
#define $derivative$$dummy xd[8]

char* getName( double* ptr)
{
  if( &$alfa == ptr ) return algvars_names[0];
  if( &$yDistance == ptr ) return algvars_names[1];
  if( &$xDistance == ptr ) return algvars_names[2];
  if( &$force == ptr ) return algvars_names[3];
  if( &$moon$pointfy == ptr ) return algvars_names[4];
  if( &$moon$pointfx == ptr ) return algvars_names[5];
  if( &$derivative$moon$pointvy == ptr ) return derivative_names[0];
  if( &$moon$pointvy == ptr ) return state_names[0];
  if( &$derivative$moon$pointvx == ptr ) return derivative_names[1];
  if( &$moon$pointvx == ptr ) return state_names[1];
  if( &$derivative$moon$pointy == ptr ) return derivative_names[2];
  if( &$moon$pointy == ptr ) return state_names[2];
  if( &$derivative$moon$pointx == ptr ) return derivative_names[3];
  if( &$moon$pointx == ptr ) return state_names[3];
  if( &$earth$pointfy == ptr ) return algvars_names[6];
  if( &$earth$pointfx == ptr ) return algvars_names[7];
  if( &$derivative$earth$pointvy == ptr ) return derivative_names[4];
  if( &$earth$pointvy == ptr ) return state_names[4];
  if( &$derivative$earth$pointvx == ptr ) return derivative_names[5];
  if( &$earth$pointvx == ptr ) return state_names[5];
  if( &$derivative$earth$pointy == ptr ) return derivative_names[6];
  if( &$earth$pointy == ptr ) return state_names[6];
  if( &$derivative$earth$pointx == ptr ) return derivative_names[7];
  if( &$earth$pointx == ptr ) return state_names[7];
  if( &$derivative$$dummy == ptr ) return derivative_names[8];
  if( &$$dummy == ptr ) return state_names[8];

  return "";
}
char init_fixed[NX+NX+NY+NP]={1, 1, 1, 1, 1, 1, 1, 1, 1, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0/*default*/, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1};
#define DIVISION(a,b,c) ((b != 0) ? a / b : a / division_error(b,c))


int encounteredDivisionByZero = 0;
double division_error(double b,const char* division_str)
{
  if(!encounteredDivisionByZero){
    fprintf(stderr,"ERROR: Division by zero in partial equation: %s.\n",division_str);
    encounteredDivisionByZero = 1;
   }   return b;
}

int functionDAE_output(double *t, double* x, double* xd, double* y, double* p)
{



  return 0;

}

/*
*/
int input_function(double *in_x,double *x, double *xd, double *y, double *p,
                   int nx, int ny, int np)
{
  return 0;

}

/*
*/
int output_function(double *out_x,double *x, double *xd, double *y, double *p,
                   int nx, int ny, int np)
{
  return 0;

}
int functionDAE_res(double *t, double *x, double *xd, double *delta, long int *ires, double *rpar, long int* ipar)
{
  int i;
  double temp_xd[NX];


  functionODE(x,temp_xd,y,p,nx,ny,np,t);
   for (i=0; i < nx; i++) delta[i]=temp_xd[i]-xd[i];
  return 0;


}
void residualFunc19(int *n, double* xloc, double* res, int* iflag)
{
  cos_rettype tmp0;
  sqrt_rettype tmp1;


  tmp0 = cos(xloc[0]);
  tmp1 = sqrt((pow($xDistance, 2.0) + pow($yDistance, 2.0)));
      res[0] = (tmp0 - ($xDistance / tmp1));


}
int function_zeroCrossing(long *neqm, double *t, double *x, long *ng, double *gout, double *rpar, long* ipar)
{



  return 0;

}
int handleZeroCrossing(long index, double *t)
{


  switch(index) {

    default: break;
  }
  return 0;

}
int function_updateDependents(double*t)
{
  sin_rettype tmp2;
  cos_rettype tmp3;


  $derivative$moon$pointy = $moon$pointvy;
  $derivative$moon$pointx = $moon$pointvx;
  $derivative$earth$pointy = $earth$pointvy;
  $derivative$earth$pointx = $earth$pointvx;
  $derivative$$dummy = 0.0;
  $force = 0.0;
  $yDistance = ($moon$pointy - $earth$pointy);
  $xDistance = ($moon$pointx - $earth$pointx);
  start_nonlinear_system(1);
  nls_x[0] = $alfa;
  hybrd_(residualFunc19,&n, nls_x,nls_fvec,&xtol,&maxfev,&ml,&mu,&epsfcn,
        nls_diag,&mode,&factor,&nprint,&info,&nfev,nls_fjac,&ldfjac,
        nls_r,&lr,nls_qtf,nls_wa1,nls_wa2,nls_wa3,nls_wa4);
    if (info == 0) {
        printf("improper input parameters to nonlinear eq. syst.\n");
    }
    if (info >= 2 && info <= 5) {
        printf("error solving nonlinear system.\n");
    }
  $alfa = nls_x[0];
  end_nonlinear_system();
  tmp2 = sin($alfa);
  $earth$pointfy = ($force * tmp2);
  $moon$pointfy = (-$earth$pointfy);
  tmp3 = cos($alfa);
  $earth$pointfx = ($force * tmp3);
  $moon$pointfx = (-$earth$pointfx);
  $derivative$moon$pointvy = ($moon$pointfy * (1.0 / $moon$pointmass));
  $derivative$moon$pointvx = ($moon$pointfx * (1.0 / $moon$pointmass));
  $derivative$earth$pointvy = ($earth$pointfy * (1.0 / $earth$pointmass));
  $derivative$earth$pointvx = ($earth$pointfx * (1.0 / $earth$pointmass));
  

  return 0;

}
int function_when(int i, double *t)
{


  switch(i) {
    default: break;
  }

  return 0;

}
void residualFunc18(int *n, double* xloc, double* res, int* iflag)
{
  cos_rettype tmp0;
  sqrt_rettype tmp1;


  tmp0 = cos(xloc[0]);
  tmp1 = sqrt((pow($xDistance, 2.0) + pow($yDistance, 2.0)));
      res[0] = (tmp0 - ($xDistance / tmp1));


}
int functionODE(double *x, double *xd, double *y, double *p, int nx, int ny, int np, double *t)
{
  sin_rettype tmp2;
  cos_rettype tmp3;


  $derivative$moon$pointy = $moon$pointvy;
  $derivative$moon$pointx = $moon$pointvx;
  $derivative$earth$pointy = $earth$pointvy;
  $derivative$earth$pointx = $earth$pointvx;
  $derivative$$dummy = 0.0;
  $force = 0.0;
  $yDistance = ($moon$pointy - $earth$pointy);
  $xDistance = ($moon$pointx - $earth$pointx);
  start_nonlinear_system(1);
  nls_x[0] = $alfa;
  hybrd_(residualFunc18,&n, nls_x,nls_fvec,&xtol,&maxfev,&ml,&mu,&epsfcn,
        nls_diag,&mode,&factor,&nprint,&info,&nfev,nls_fjac,&ldfjac,
        nls_r,&lr,nls_qtf,nls_wa1,nls_wa2,nls_wa3,nls_wa4);
    if (info == 0) {
        printf("improper input parameters to nonlinear eq. syst.\n");
    }
    if (info >= 2 && info <= 5) {
        printf("error solving nonlinear system.\n");
    }
  $alfa = nls_x[0];
  end_nonlinear_system();
  tmp2 = sin($alfa);
  $earth$pointfy = ($force * tmp2);
  $moon$pointfy = (-$earth$pointfy);
  tmp3 = cos($alfa);
  $earth$pointfx = ($force * tmp3);
  $moon$pointfx = (-$earth$pointfx);
  $derivative$moon$pointvy = ($moon$pointfy * (1.0 / $moon$pointmass));
  $derivative$moon$pointvx = ($moon$pointfx * (1.0 / $moon$pointmass));
  $derivative$earth$pointvy = ($earth$pointfy * (1.0 / $earth$pointmass));
  $derivative$earth$pointvx = ($earth$pointfx * (1.0 / $earth$pointmass));

  return 0;

}
int initial_function(double *x, double *xd, double *y, double *p, double *t, int nx, int ny, int np)
{


  $earth$pointmass = (5.9736 * ((modelica_real)pow(10, 24)));
  $moon$pointmass = (7.347673 * ((modelica_real)pow(10, 22)));

  return 0;

}
int initial_residual(double *x, double *xd, double *y, double *p, double *t, int nx, int ny, int np, double *res, int nr)
{
  cos_rettype tmp0;
  sqrt_rettype tmp1;
  cos_rettype tmp2;
  sin_rettype tmp3;
  int i=0;


  res[i++] = ($earth$pointfx - ($earth$pointmass * $derivative$earth$pointvx));
  res[i++] = ($earth$pointfy - ($earth$pointmass * $derivative$earth$pointvy));
  res[i++] = ($moon$pointfx - ($moon$pointmass * $derivative$moon$pointvx));
  res[i++] = ($moon$pointfy - ($moon$pointmass * $derivative$moon$pointvy));
  res[i++] = ($xDistance - ($moon$pointx - $earth$pointx));
  res[i++] = ($yDistance - ($moon$pointy - $earth$pointy));
  tmp0 = cos($alfa);
  tmp1 = sqrt((pow($xDistance, 2.0) + pow($yDistance, 2.0)));
  res[i++] = (tmp0 - ($xDistance / tmp1));
  res[i++] = $force;
  tmp2 = cos($alfa);
  res[i++] = ($earth$pointfx - ($force * tmp2));
  tmp3 = sin($alfa);
  res[i++] = ($earth$pointfy - ($force * tmp3));
  res[i++] = ($earth$pointfx + $moon$pointfx);
  res[i++] = ($earth$pointfy + $moon$pointfy);
  res[i++] = $derivative$$dummy;
  res[i++] = ($derivative$earth$pointx - $earth$pointvx);
  res[i++] = ($derivative$earth$pointy - $earth$pointvy);
  res[i++] = ($derivative$moon$pointx - $moon$pointvx);
  res[i++] = ($derivative$moon$pointy - $moon$pointvy);
  res[i++] = ($moon$pointvy - 1023.14);
  res[i++] = $moon$pointvx;
  res[i++] = $moon$pointy;
  res[i++] = ($moon$pointx - 384400000.0);
  res[i++] = $earth$pointvy;
  res[i++] = $earth$pointvx;
  res[i++] = $earth$pointy;
  res[i++] = $earth$pointx;

  return 0;

}
int bound_parameters(double *x, double *xd, double *y, double *p, double *t, int nx, int ny, int np)
{


  $earth$pointmass = (5.9736 * ((modelica_real)pow(10, 24)));
  $moon$pointmass = (7.347673 * ((modelica_real)pow(10, 22)));
  return 0;


}
int checkForDiscreteVarChanges(double *t)
{
return 0;
}
